//按钮事件绑定标志
var isBindingEvent = 0;

//日期按钮禁用状态
var lastAndNextMonthButtonsDisabled = false;

//获取事件列表的连接串
var requestEventsListUrl = "http://alumnet.nus.edu.sg/website/getEventDetailList";

//获取当前日期
var currentEventListDate = new Date();

//当前年份
var currentYear = currentEventListDate.getFullYear();
//当前月份
var currentMonth = currentEventListDate.getMonth() + 1;

//page出现的时候调用
$(document).on("pagebeforecreate", "#NusEventsView", function () {
    if (isBindingEvent) {
        return;
    }
 
    //绑定事件
    bindingEvent();
    
	//获取网络数据
	getNusEventListByDate();

    //设置按钮已经被绑定了事件
    isBindingEvent = 1;
});

var bindingEvent = function () {
    $("#ToolBarEventsButton1").on("tap",eventsToolBarButtonClicked);
    $("#ToolBarSocialButton1").on("tap",socialToolBarButtonClicked);
    $("#ToolBarContactButton1").on("tap",contactToolBarButtonClicked);
    $("#LastMonthEventsButton").on("tap",lastMonthButtonClicked);
    $("#NextMonthEventsButton").on("tap",nextMonthButtonClicked);
};

//事件
var eventsToolBarButtonClicked = function () {
	$.mobile.changePage("index_events.html",{transition:"none"});
};

//社交
var socialToolBarButtonClicked = function () {
	$.mobile.changePage("index_social.html",{transition:"none"});
};

//联络
var contactToolBarButtonClicked = function () {
	$.mobile.changePage("index_contact.html",{transition:"none"});
};

//事件详情
var eventItemClicked = function(eventId){
	$.mobile.changePage("eventDetail.html?eventId="+eventId+"",{transition:"slidefade"});
}

//上一个月点击事件
var lastMonthButtonClicked = function (){
	
	//判断按钮是否禁用
	if(!lastAndNextMonthButtonsDisabled){
		
		currentMonth = currentMonth - 1;
	
		if(currentMonth == 0){
			currentMonth = 12;
			currentYear = currentYear - 1;	
		}
		
		//请求上个月事件数据
		getNusEventListByDate();
	}
}

//下一个月点击事件
var nextMonthButtonClicked = function (){
	
	//判断按钮是否禁用
	if(!lastAndNextMonthButtonsDisabled){
	
		currentMonth = currentMonth + 1;
	
		if(currentMonth == 13){
			currentMonth = 1;
			currentYear = currentYear + 1;
		}
		
		//请求下个月事件数据
		getNusEventListByDate();	
	}
}

//更新当前月份标签
var updateCurrentMonthLabel = function(){
	
	//中间日期标签
	var EventMonthLabel = document.getElementById("EventMonthLabel");
	EventMonthLabel.innerHTML = getCurrentMonthByMonthNumber() + " " + currentYear;
}

//获取开始时间
var getEventsListBeginDate = function(){
	
	var beginDate = '01/' + currentMonth + '/' + currentYear;
	
	return beginDate;
}

//获取结束时间
var getEventsListEndDate = function(){
	
	var nextMonth = currentMonth + 1;
	var nextYear = currentYear;
	
	if(nextMonth > 12){
		nextMonth = 1;
		
		nextYear = nextYear + 1;
	}
	
	var endDate = '01/' + nextMonth + '/' + nextYear;
	
	return endDate;
}

//获取当前英文月份
var getCurrentMonthByMonthNumber = function(){
	
	var currentMonthEnglishText = "";
	
	switch (currentMonth)
	{
		case 1:
			currentMonthEnglishText = "January";
		break;
		case 2:
			currentMonthEnglishText = "February";
		break;
		case 3:
			currentMonthEnglishText = "March";		
		break;
		case 4:
			currentMonthEnglishText = "April";
		break;
		case 5:
			currentMonthEnglishText = "May";
		break;
		case 6:
			currentMonthEnglishText = "June";
		break;
		case 7:
			currentMonthEnglishText = "July";
		break;
		case 8:
			currentMonthEnglishText = "August";
		break;
		case 9:
			currentMonthEnglishText = "September";
		break;
		case 10:
			currentMonthEnglishText = "October";
		break;
		case 11:
			currentMonthEnglishText = "November";
		break;
		case 12:
			currentMonthEnglishText = "December";
		break;
	}
	
	return currentMonthEnglishText;
} 

//获取事件列表
var getNusEventListByDate = function () {

	//事件展示列表
	var eventsList = document.getElementById("EventList");

	//上个月按钮
	var LastMonthEventsButton = document.getElementById("LastMonthEventsButton");
	//下个月按钮
	var NextMonthEventsButton = document.getElementById("NextMonthEventsButton");
	//中间日期标签
	var EventMonthLabel = document.getElementById("EventMonthLabel");

	//禁用按钮点击事件
	lastAndNextMonthButtonsDisabled = true;
    
	//显示加载进度
    $.mobile.loading("show");
	
	//请求链接当中嵌套的数据
	var eventsListData = {
		'event.status':'20',
		'event.startDate':getEventsListBeginDate(),
		'event.endDate':getEventsListEndDate()
	};
	
	$.ajax({
            url: requestEventsListUrl,
            dataType: "jsonp",
			data: eventsListData,
			complete: function(XMLHttpRequest, textStatus){
				//请求发出去之后调用
			},
			error: function(XMLHttpRequest, textStatus, errorThrown){
				//失败
           
				//隐藏加载进度
				$.mobile.loading("hide");
				
				//更新月份标签
				updateCurrentMonthLabel();
	
				//禁用按钮点击事件
				lastAndNextMonthButtonsDisabled = false;
			},
            success: function(json){
	            //成功
	            //清空列表数据
            	$('.EventList').empty();
            	$('.EventListDisplayView').empty();
           
			    if(json != '' && json != null){
				    //遍历数据数组
				    for(var i = 0; i < json.length ; i++){
					    var div = $('<div/>');
                        var newImageUrl = json[i].photoUrl.replace("localhost:8080","alumnet.nus.edu.sg");
					    div.attr('class', 'EventListItem');
					    div.append('<a onclick="eventItemClicked('+json[i].eventId+')"  data-transition="slidefade" class="EventListItemLinkStyle">'
					    +'<img class="EventListItemForwardImg" src="Resources/icon-forward.png">'	
					    +'<img class="EventListItemImage" src="'+newImageUrl+'"/>'+
					    '<dt class="EventListItemTitle">'+zhuanyi(json[i].title)+'</dt>'
					    +'<dt>' + '<img class="EventListItemDateImage" src="Resources/icon-date.png">'+
						'<span class="EventListItemDate">'+json[i].startDate+'</span>' + '</dt>' +
						'<dt class="EventListItemSeperator">' + '<hr noshade color="#e0e1e5" size=2>'+
						'</dt>' + '</a>');
					    $('.EventList').append(div);
					    
					    div = null;
			    	}
			    	
			    	//隐藏加载进度
					$.mobile.loading("hide");
					
					//更新月份标签
					updateCurrentMonthLabel();
		
					//禁用按钮点击事件
					lastAndNextMonthButtonsDisabled = false;
				}
				else{
                    showEventListUnanailable();
           
				    //隐藏加载进度
					$.mobile.loading("hide");
					
					//更新月份标签
					updateCurrentMonthLabel();
		
					//禁用按钮点击事件
					lastAndNextMonthButtonsDisabled = false;
			    }
            }
        });
};

function showAlert() {
    navigator.notification.alert(
                                 'Thank you for your interest in our events.<br><br>We are sorry that no event has been scheduled yet for this month.<br><br>If you are an NUS alumnus, you may wish to subscribe to our e-Newsletters by clicking <a target="_blank" href="https://alum.nus.edu.sg/update/">here</a>.',
                                 alertDismissed, //callback
                                 'Alumnet',
                                 'OK'
                                 );  
}

function showEventListUnanailable() {
	var message = 'Thank you for your interest in our events.<br><br>We are sorry that no event has been scheduled yet for this month.<br><br>If you are an NUS alumnus, you may wish to subscribe to our e-Newsletters by clicking <a target="_blank" href="https://alum.nus.edu.sg/update/">here</a>.';
	
	var EventDisplayLabel = document.getElementById("EventListDisplayLabel");
	
	EventDisplayLabel.innerHTML = '<h1 style="text-align:left;padding-left:30px;padding-right:30px;">' + message + '</h1>';
}

function alertDismissed() {
    //点击OK回调函数
}

function callback(data){
	alert(data);
}

function zhuanyi(name){
	if (name != undefined) {
		while (true) {
			if (name.indexOf('&#38#39') != -1 || name.indexOf('&#38#38#44')!=-1) {
				name = name.replace('&#38#39', "'");
				name = name.replace('&#38#38#44', ",");
			} else {
				break;
			}
		}
	}
	return name;
}




